
Opt('GUICloseOnESC', 0)
Opt('GUIOnEventMode', 1)
Opt('MustDeclareVars', 1)
Opt('MouseCoordMode', 2)

#include 'Blubb.au3'

_Image_Startup()
_GDIPlus_Startup()

Global $a[65536]
_ArraysFuellen() ; Fllt die Arrays mit Werten.

Global Const $pFile = '\1.png', $iAnzeigeB = 300, $iAnzeigeH = 300

Global $hGUI, $hDC, $hBuf, $hDC_Buf, $hImage, $iBreite, $iHoehe, $hCopy, $hBtn, $hGUI_Ausgabe, $hAusgabe, $hBtn_Loeschen, $hBtn_Ausgabe, $hBtn_Zurueck, $ARGB_Slider[4], $ARGB_Input[4], $ARGB_Label[4], _
$hBtn_ZielSuche, $hInput_Ziel, $hInput_UpDown, $iZoom

$hImage = _Image_CreateFromFile(@ScriptDir & $pFile)
$hCopy = _Image_CreateFromFile(@ScriptDir & $pFile)

$iBreite = 2 * DllStructGetData($hImage, 1, 2)
$iHoehe = DllStructGetData($hImage, 1, 3)

$iZoom = Int(400/(($iBreite/2)^2+$iHoehe^2)^0.5)

$iBreite *= $iZoom
$iHoehe *= $iZoom


$hGUI = GUICreate('8888', $iBreite, $iHoehe + 160)
$hBtn = GUICtrlCreateButton('Umwandeln', 5, $iHoehe + 5, 100, 30)
$hBtn_Ausgabe = GUICtrlCreateButton('Ausgabe anzeigen', 110, $iHoehe + 5, 100, 30)
$hBtn_Zurueck = GUICtrlCreateButton('Zurcksetzen', 215, $iHoehe + 5, 100, 30)
$hBtn_ZielSuche = GUICtrlCreateButton('Optimieren', 320, $iHoehe + 5, 100, 30)
$hInput_Ziel = GUICtrlCreateInput(3, 320, $iHoehe + 45, 50, 20)
$hInput_UpDown = GUICtrlCreateUpdown($hInput_Ziel)
GUICtrlSetLimit($hInput_UpDown, 31, 1)

For $i = 0 To 3 Step 1
	$ARGB_Slider[$i] = GUICtrlCreateSlider(5, $iHoehe + 45 + 25*$i, 100, 25, 0x0010)
	GUICtrlSetLimit(-1, 8, 0)
	GUICtrlSetData(-1, (6 - $i)*($i<>0))
	GUICtrlSetOnEvent(-1, '_Slider')
	$ARGB_Label[$i] = GUICtrlCreateLabel(GUICtrlRead($ARGB_Slider[$i]), 110, $iHoehe + 50 + 25*$i, 25, 17)
	GUICtrlCreateLabel(StringMid('AlphaRot  Grn Blau ', $i*5+1, 5), 135, $iHoehe + 50 + 25*$i, 30, 17)
Next

$hGUI_Ausgabe = GUICreate('Ausgabe', $iAnzeigeB, $iAnzeigeH + 40, 10, 10)
$hAusgabe = GUICtrlCreateEdit('', 2, 2, $iAnzeigeB-4, $iAnzeigeH-4, 2048 + 0x00200000)
$hBtn_Loeschen = GUICtrlCreateButton('Lschen', 5, $iAnzeigeH + 5, 100, 30)

$hBuf = _Image_Create($iBreite, $iHoehe)
$hDC_Buf = DllStructGetData($hBuf, 1, 1)

$hDC = _WinAPI_GetDC($hGUI)

GUICtrlSetFont($hAusgabe, 12, 100, 0, 'Courier New', 5)

GUISetOnEvent(-3, '_Exit', $hGUI)
GUISetOnEvent(-3, '_Hide', $hGUI_Ausgabe)

GUICtrlSetOnEvent($hBtn_Loeschen, '_Loeschen')
GUICtrlSetOnEvent($hBtn_Zurueck, '_Zurueck')
GUICtrlSetOnEvent($hBtn_Ausgabe, '_Show')
GUICtrlSetOnEvent($hBtn_ZielSuche, '_Optimieren')
GUICtrlSetOnEvent($hBtn, '_Konvertieren')

GUIRegisterMsg(0xF, 'WM_PAINT')

GUISetState(@SW_SHOW, $hGUI)
GUISetState(@SW_SHOW, $hGUI_Ausgabe)

_Slider()
_Konvertieren()
_Redraw()


While Sleep(100)
WEnd

Func _Optimieren()

	_Loeschen()

	Local $iMaxBits = Int(GUICtrlRead($hInput_Ziel))
	If Not $iMaxBits Then
		_Consolewrite('Falsche Eingabe bei der Optimierung')
		Return
	EndIf

	_Consolewrite('Suche optimale Lsung fr ' & @CRLF & $iMaxBits & ' Bits...' & @CRLF)
	_Consolewrite('Dieser Vorgang kann einige Minuten dauern...' & @CRLF)

	Local $A = 0, $R = 0, $G = 0, $B = 0

	Local $iAbweichungPX = 768 ; Sie sollte in jedem Fall kleiner sein^^
	Local $TMP_AbweichungPX
	Local $TMP_Einstellungen[4]


	For $R = 0 To _Min($iMaxBits,8) Step 1
		For $G = 0 To _Min($iMaxBits,8) Step 1
			For $B = 0 To _Min($iMaxBits,8) Step 1

				If ($A + $R + $G + $B) <= $iMaxBits Then ; Alle Kombinationen.
					Sleep(10) ; Wie wollen der CPU ruhig Luft gnnen.

					$ARGB_Input[0] = $A
					$ARGB_Input[1] = $R
					$ARGB_Input[2] = $G
					$ARGB_Input[3] = $B

					For $i = 0 To 3 Step 1
						GUICtrlSetData($ARGB_Slider[$i], $ARGB_Input[$i])
						GUICtrlSetData($ARGB_Label[$i], $ARGB_Input[$i])
					Next

					$TMP_AbweichungPX = _Konvertieren(False)

;~ 					_Consolewrite($TMP_AbweichungPX & @CRLF & $iAbweichungPX)
;~ 					_Redraw()

					If $TMP_AbweichungPX < $iAbweichungPX Then
						$iAbweichungPX = $TMP_AbweichungPX
						_Consolewrite($A & $R & $G & $B & ' - ' & Round(Log2($iAbweichungPX),2) & ' Bit/Px')
						$TMP_Einstellungen[0] = $A
						$TMP_Einstellungen[1] = $R
						$TMP_Einstellungen[2] = $G
						$TMP_Einstellungen[3] = $B
					EndIf

				EndIf

			Next
		Next
	Next

;~ 	_Loeschen()

	_Consolewrite(@CRLF & 'Minimum gefunden bei: ' & @CRLF & $TMP_Einstellungen[0] & _
	$TMP_Einstellungen[1] & $TMP_Einstellungen[2] & $TMP_Einstellungen[3] & _
	' - ' & Round(Log2($iAbweichungPX),2) & ' Bit/Px')

	For $i = 0 To 3 Step 1
		GUICtrlSetData($ARGB_Slider[$i], $TMP_Einstellungen[$i])
	Next

	_Slider()

	_Konvertieren(False)










EndFunc

Func _Min($a, $b)
	If $a < $b Then Return $a
	Return $b
EndFunc

Func _Slider()
	For $i = 0 To 3 Step 1
		$ARGB_Input[$i] = Int(GUICtrlRead($ARGB_Slider[$i]))
		GUICtrlSetData($ARGB_Label[$i], $ARGB_Input[$i])
	Next
EndFunc

Func _Abweichung($iCol_1, $iCol_2)

	; Beides sind 32Bit Farben.

	Local $_1_ARGB[4], $_2_ARGB[4], $iAbweichung

	$iCol_1 = Hex($iCol_1,8)
	$iCol_2 = Hex($iCol_2,8)

	For $i = 0 To 3 Step 1
		$_1_ARGB[$i] = '0x' & StringMid($iCol_1, $i*2+1, 2)
		$_2_ARGB[$i] = '0x' & StringMid($iCol_2, $i*2+1, 2)
		$iAbweichung += Abs(Int($_1_ARGB[$i]) - Int($_2_ARGB[$i]))
	Next

	Return $iAbweichung

EndFunc

Func _Konvertieren($Konsole = True)

	If Not IsDeclared('Konsole') Then
		Assign('Konsole', True)
;~ 		$Konsole = True
	EndIf

	If $Konsole Then _Loeschen()

	Local $_1 = '8888'
	Local $_2 = _MaskToString($ARGB_Input)

	Local $iPX = DllStructGetData($hImage, 1, 2) * DllStructGetData($hImage, 1, 2)
	Local $Bpp = $ARGB_Input[0] + $ARGB_Input[1] + $ARGB_Input[2] + $ARGB_Input[3]

	If $Konsole Then _Consolewrite('Input: ' & @CRLF & 'Anzahl Pixel: ' & $iPX)
	If $Konsole Then _Consolewrite('Bit/Px: ' & 32 & @CRLF & 'Bytes: ' & $iPX * 4 & @CRLF)

	Local $t = TimerInit()

	Local $iAbweichung = _SetBitDepth($hImage, $hCopy, _StringToMask($_1), $ARGB_Input)

	$t = TimerDiff($t)
	If $Konsole Then _Consolewrite('Output: ' & @CRLF & 'Bit/Px: ' & $Bpp)
	If $Konsole Then _Consolewrite('Bytes: ' & $iPX * $Bpp/8)
	If $Konsole Then _Consolewrite('Zeit: ' & Round($t, 0) & ' ms' & @CRLF)
	If $Konsole Then _Consolewrite('Abweichung vom Original: ' & @CRLF & $iAbweichung & ' - ' & Round(Log2($iAbweichung/$iPX),2) & ' Bit/Px')

	_Redraw()

	WinSetTitle($hGUI, '', $_1 & ' -> ' & $_2)

	Return $iAbweichung/$iPX

EndFunc   ;==>_Konvertieren

Func Log2($Zahl)
	Return Log($Zahl) / Log(2)
EndFunc

Func _SetBitDepth($vImg, $vCopy, $sMask_Input, $sMask_Output)

	Local $iB = DllStructGetData($vImg, 1, 2), $iH = DllStructGetData($vImg, 1, 3), $iPX = $iH * $iB
	Local $vStruct = DllStructCreate('int[' & $iPX & ']', DllStructGetData($vImg, 1, 4))
	Local $vStruct_Copy = DllStructCreate('int[' & $iPX & ']', DllStructGetData($vCopy, 1, 4))
	Local $iAbweichung = 0

	For $i = 1 To $iPX Step 1
;~ 		$sTMP =
;~ 		_Consolewrite($sTMP)
	DllStructSetData($vStruct_Copy, 1, _BitBit('0x' & Hex(DllStructGetData($vStruct, 1, $i), 8), $sMask_Input, $sMask_Output), $i)
	$iAbweichung += _Abweichung(DllStructGetData($vStruct, 1, $i),DllStructGetData($vStruct_Copy, 1, $i))


	Next

	Return $iAbweichung

EndFunc   ;==>_SetBitDepth

Func _BitBit($i, $a1, $a2)
	Return _BitChange(_BitChange($i, $a1, $a2), $a2, $a1)
EndFunc   ;==>_BitBit

Func _Exit()
	Exit
EndFunc   ;==>_Exit

Func _Consolewrite($a)
	GUICtrlSetData($hAusgabe, $a & @CRLF, 1)
EndFunc   ;==>_Consolewrite

Func _Loeschen()
	GUICtrlSetData($hAusgabe, '')
EndFunc   ;==>_Loeschen

Func _Hide()
	GUISetState(@SW_HIDE, $hGUI_Ausgabe)
EndFunc   ;==>_Hide

Func _Show()
	GUISetState(@SW_SHOW, $hGUI_Ausgabe)
	GUISetState(@SW_RESTORE, $hGUI_Ausgabe)
EndFunc   ;==>_Show

Func _Redraw()
	_Winapi_StretchBlt($hDC_Buf, 0, 0, $iBreite / 2, $iHoehe, DllStructGetData($hImage, 1, 1), 0, 0, DllStructGetData($hImage, 1, 2), DllStructGetData($hImage, 1, 3), 0xCC0020)
	_Winapi_StretchBlt($hDC_Buf, $iBreite / 2, 0, $iBreite / 2, $iHoehe, DllStructGetData($hCopy, 1, 1), 0, 0, DllStructGetData($hCopy, 1, 2), DllStructGetData($hCopy, 1, 3), 0xCC0020)
	WM_PAINT()
EndFunc   ;==>_Redraw

Func _Zurueck()
	_WinAPI_BitBlt(DllStructGetData($hCopy, 1, 1), 0, 0, DllStructGetData($hCopy, 1, 2), DllStructGetData($hCopy, 1, 3), DllStructGetData($hImage, 1, 1), 0, 0, 0xCC0020)
	_Redraw()
	WinSetTitle($hGUI, '', '8888')
EndFunc   ;==>_Zurueck

Func WM_PAINT()
	_WinAPI_BitBlt($hDC, 0, 0, $iBreite, $iHoehe, $hDC_Buf, 0, 0, 0xCC0020)
EndFunc   ;==>WM_PAINT

Func _Freigeben()

	_WinAPI_ReleaseDC($hGUI, $hDC)
	_Image_Delete($hImage)
	_Image_Delete($hCopy)

	_GDIPlus_Shutdown()
	_Image_Shutdown()

EndFunc   ;==>_Freigeben

; iInput muss eine maximal 32Bit groe Integerzahl sein.
; Sie muss als Zahl vorliegen (entweder nur Dezimalzahlen oder 0xHEX)
; Die Inputzahl muss zu der Maske passen, sonst klappts nicht.

Func _BitChange($iInput, $aMask_Input, $aMask_Output)

	; Funtkionsweise:
	; Berechnung der einzelnen Werte per Mal und Geteiltrechnung.
	; (Kommas werden somit bercksichtigt sodass durch Runden das volle Spektrum erhalten bleibt)
	; Nur Mit Shift Befehlen wird z.B. aus 111 (3Bit 100% Wei) 11100000 (8Bit. aber nicht 100% Wei)

	Local $ARGB[4], $sRet = ''

	Local $hInput = _ToBin($iInput)

	For $i = 3 To 0 Step -1
		$ARGB[$i] = _TD(StringRight($hInput, $aMask_Input[$i]))
		$hInput = StringTrimRight($hInput, $aMask_Input[$i])
	Next

	For $i = 0 To 3 Step 1
		$ARGB[$i] = Round(($ARGB[$i] / (2 ^ $aMask_Input[$i] - 1)) * (2 ^ $aMask_Output[$i] - 1), 0)
;~ 		If $ARGB[$i] > (2^$aMask_Output[$i] - 1) Then $ARGB[$i] = (2^$aMask_Output[$i] - 1)
		If $aMask_Input[$i] > 0 Then
			$sRet &= StringRight(_ToBin($ARGB[$i]), $aMask_Output[$i]) & ' '
		Else
			If $i = 0 Then ; Alpha
				$sRet &= StringRight('11111111', $aMask_Output[$i]) & ' '
			Else
				$sRet &= StringRight('00000000', $aMask_Output[$i]) & ' '
			EndIf
		EndIf
	Next

	Return _TD($sRet)

EndFunc   ;==>_BitChange

Func _StringToMask($s)
	Local $aRet[4] = [StringLeft($s, 1), StringMid($s, 2, 1), StringMid($s, 3, 1), StringRight($s, 1)]
	Return $aRet
EndFunc   ;==>_StringToMask

Func _MaskToString($aM)
	Local $sRet = ''
	For $i = 0 To 3 Step 1
		$sRet &= $aM[$i]
	Next
	Return $sRet
EndFunc   ;==>_MaskToString

Func _Gliedern($sBin, $aM)
	Local $iTMP
	For $i = 3 To 0 Step -1
		$iTMP = $aM[$i]
		$aM[$i] = StringLeft('        ', 8 - $iTMP) & StringRight($sBin, $aM[$i])
		$sBin = StringTrimRight($sBin, $iTMP)
	Next
	$sBin = ''
	For $i = 0 To 3 Step 1
		$sBin &= $aM[$i] & ' '
	Next
	Return $sBin
EndFunc   ;==>_Gliedern

Func SHR($iInt, $iCount) ; 32Bit ShiftRight
	Local $sInt = StringLeft('00000000000000000000000000000000', $iCount) & StringTrimRight(_ToBin($iInt), $iCount)
	Return '0x' & _4TH(StringLeft($sInt, 4)) & _4TH(StringMid($sInt, 5, 4)) & _4TH(StringMid($sInt, 9, 4)) & _4TH(StringMid($sInt, 13, 4)) & _4TH(StringMid($sInt, 17, 4)) & _4TH(StringMid($sInt, 21, 4)) & _4TH(StringMid($sInt, 25, 4)) & _4TH(StringMid($sInt, 29, 4))
EndFunc   ;==>SHR

Func SHL($iInt, $iCount) ; 32Bit ShiftLeft
	Local $sInt = StringTrimLeft(_ToBin($iInt), $iCount) & StringLeft('00000000000000000000000000000000', $iCount)
	Return '0x' & _4TH(StringLeft($sInt, 4)) & _4TH(StringMid($sInt, 5, 4)) & _4TH(StringMid($sInt, 9, 4)) & _4TH(StringMid($sInt, 13, 4)) & _4TH(StringMid($sInt, 17, 4)) & _4TH(StringMid($sInt, 21, 4)) & _4TH(StringMid($sInt, 25, 4)) & _4TH(StringMid($sInt, 29, 4))
EndFunc   ;==>SHL

Func UINT($iInt)
	Local $s = DllStructCreate('int')
	DllStructSetData($s, 1, $iInt)
	Local $u = DllStructCreate('uint', DllStructGetPtr($s))
	Return DllStructGetData($u, 1)
EndFunc   ;==>UINT

Func _TD($i) ; ToDec Variable Bit Umwandlung von Bin zu Dec
	$i = StringReplace($i, ' ', '')
	Local $iRet = 0, $iLen = StringLen($i)
	For $e = $iLen To 1 Step -1
		$iRet += 2 ^ ($iLen - $e) * Int(StringMid($i, $e, 1))
	Next
	Return $iRet
EndFunc   ;==>_TD

Func _4TH($i) ; Wandelt vier Binrzahlen (0101) in eine Hexadezimale Zahl. (F)
	Return Hex(8 * Int(StringLeft($i, 1)) + 4 * Int(StringMid($i, 2, 1)) + 2 * Int(StringMid($i, 3, 1)) + 1 * Int(StringRight($i, 1), 1), 1)
EndFunc   ;==>_4TH

Func _ToBin($iD) ; 32Bit Umwandlung von Dezimal zu Binr
	$iD = Hex(Int($iD), 8)
	Return $a['0x' & StringLeft($iD, 4)] & $a['0x' & StringRight($iD, 4)]
EndFunc   ;==>_ToBin

Func _ArraysFuellen() ; Fllt $a und $b mit Werten
	Local $sH, $aB[16] = ['0000', '0001', '0010', '0011', '0100', '0101', '0110', '0111', '1000', '1001', '1010', '1011', '1100', '1101', '1110', '1111']
	For $i = 0 To 65535
		$sH = Hex($i, 4)
		For $_i = 1 To StringLen($sH) Step 1
			$a[$i] &= $aB[Int('0x' & StringMid($sH, $_i, 1))]
		Next
	Next
EndFunc   ;==>_ArraysFuellen

Func _Image_SaveTrans($__Img, $__Pfad = '')

	If Not $__Pfad Then $__Pfad = FileSaveDialog('Bitte Ziel aussuchen', @ScriptDir, 'Png-Bild(*.png)')
	If @error Then Return 0
	If StringRight($__Pfad, 4) <> '.png' Then $__Pfad &= '.png'

	Local $__B, $__H, $__GFX, $__BMP, $__BUF, $__Struct

	$__B = DllStructGetData($__Img, 1, 2)
	$__H = DllStructGetData($__Img, 1, 3)

	$__GFX = _GDIPlus_GraphicsCreateFromHDC(DllStructGetData($__Img, 1, 1))
	$__BMP = _GDIPlus_BitmapCreateFromGraphics($__B, $__H, $__GFX)
	$__BUF = _GDIPlus_ImageGetGraphicsContext($__BMP)
	_GDIPlus_GraphicsClear($__BUF, 0x00000000)

	$__Struct = DllStructCreate('int[' & $__B * $__H & ']', DllStructGetData($__Img, 1, 4))

	For $y = 0 To $__H Step 1
		For $x = 0 To $__B Step 1
			DllCall($ghgdipdll, 'uint', 'GdipBitmapSetPixel', 'hwnd', $__BMP, 'int', $x, 'int', $y, 'uint', DllStructGetData($__Struct, 1, $x + $y * $__B + 1))
		Next
	Next

	_GDIPlus_ImageSaveToFile($__BMP, $__Pfad)
	_GDIPlus_GraphicsDispose($__BUF)
	_GDIPlus_BitmapDispose($__BMP)
	_GDIPlus_GraphicsDispose($__GFX)

	Return 1

EndFunc   ;==>_Image_SaveTrans

Func _WinAPI_StretchBlt($hDestDC, $iXDest, $iYDest, $iWidth, $iHeight, $hSrcDC, $iXSrc, $iYSrc, $iB2, $iH2, $iROP)
	DllCall($___IMAGEUDF_DLL_GDI32, 'bool', 'StretchBlt', 'handle', $hDestDC, 'int', $iXDest, 'int', $iYDest, 'int', $iWidth, 'int', $iHeight, 'handle', $hSrcDC, 'int', $iXSrc, 'int', $iYSrc, 'int', $iB2, 'int', $iH2, 'dword', $iROP)
EndFunc   ;==>_WinAPI_StretchBlt
